Wednesday, May 29, 2024

[LeetCode] IPO

Problem: Suppose LeetCode will start its IPO soon. In order to sell a good price of its shares to Venture Capital, LeetCode would like to work on some projects to increase its capital before the IPO. Since it has limited resources, it can only finish at most k distinct projects before the IPO. Help LeetCode design the best way to maximize its total capital after finishing at most k distinct projects.

You are given n projects where the ith project has a pure profit profits[i] and a minimum capital of capital[i] is needed to start it.

Initially, you have w capital. When you finish a project, you will obtain its pure profit and the profit will be added to your total capital.

Pick a list of at most k distinct projects from given projects to maximize your final capital, and return the final maximized capital.

The answer is guaranteed to fit in a 32-bit signed integer.

Example:

Input: k = 2, w = 0, profits = [1,2,3], capital = [0,1,1]
Output: 4
Explanation: Since your initial capital is 0, you can only start the project indexed 0.
After finishing it you will obtain profit 1 and your capital becomes 1.
With capital 1, you can either start the project indexed 1 or the project indexed 2.
Since you can choose at most 2 projects, you need to finish the project indexed 2 to get the maximum capital.
Therefore, output the final maximized capital, which is 0 + 1 + 3 = 4.
Input: k = 3, w = 0, profits = [1,2,3], capital = [0,1,2]
Output: 6


Approach: We are going to be greedy here. Here are the steps for solving this problem:

  1. Choose what pojects can be taken: We need to get all the projects that can be done using the current capital. Basically all the projects whose capital is less than or equal to current capital. (To do it efficiently we can first sort the projects based on capital and then enter into this step).
  2. Choose the project with max profit from the above projects: Now that we have got all the projects that can be done based on current capital we need to choose the project with max profit among these projects. To do it, we can store doable projects in the max heap based on profit of projects. We need to add this project's profit to current capital

Using the above 2 steps repeatedly k times, we will get the maximum possible capital. That's all!


Implementation in C#: 

public class Project
{
    public int Capital {get; set;}
    public int Profit {get; set;}
    public Project(int capital = 0, int profit = 0)
    {
        this.Capital = capital;
        this.Profit = profit;
    }
}

public class IntMaxComparer : IComparer<int>
{
    public int Compare(int i, int j) => j.CompareTo(i);
}

public class Solution {
    public int FindMaximizedCapital(int k, int w, int[] profits, int[] capital)
    {
        int length = profits?.Length ?? 0;
        if (length == 0)
        {
            return 0;
        }
        var projects = this.GetSortedProjects(profits, capital);
        // Max heap
        var pq = new PriorityQueue<Project, int>(new IntMaxComparer());
        int currIndex = 0;
        for (int i = 0; i < k; ++i)
        {
            while(currIndex < length &&
projects[currIndex].Capital <= w)
            {
                pq.Enqueue(projects[currIndex],
projects[currIndex].Profit);
                ++currIndex;
            }
            if (pq.Count == 0)
            {
                break;
            }
            var qProject = pq.Dequeue();
            w += qProject.Profit;
        }
        return w;
    }

    private Project[] GetSortedProjects(int[] profits, int[] capital)
    {
        var projects = new Project[profits.Length];
        for (int i = 0; i < profits.Length; ++i)
        {
            projects[i] = new Project(capital[i], profits[i]);
        }
        Array.Sort(projects, (p1, p2) => {
            return p1.Capital.CompareTo(p2.Capital);
        });
        return projects;
    }
}

Complexity: O(nlogn + klogn)

No comments:

Post a Comment